



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>NGINX(三)HASH表</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">NGINX(三)HASH表</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-01-31 08:42:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<h2>前言</h2>
<p>nginx的hash表有几种不同的种类, 不过都是以ngx_hash_t为基础的, ngx_hash_t是最普通的hash表, 冲突采用的是链地址法, 不过这里冲突的元素不是一个链表, 而是一个数组, 为了加快访存速度,这种hash表只用于存储一些静态的信息, 例如所有头部信息, 配置信息等等.</p>
<h2>涉及数据结构</h2>
<pre class="prettyprint linenums"><code>/*hash元素数据结构包含key和value*/<br />
typedef struct {<br />
	/*hash值*/<br />
    void             *value;<br />
	/*hash表原始key的长度, 即name长度*/<br />
    u_short           len;<br />
	/*name即原始的key值*/<br />
    u_char            name[1];<br />
} ngx_hash_elt_t;

/*普通hash表*/<br />
typedef struct {<br />
	/*hash元素*/<br />
    ngx_hash_elt_t  **buckets;<br />
	/*hash表中元素数量*/<br />
    ngx_uint_t        size;<br />
} ngx_hash_t;

/*hash表中key数据结构, 主要用于传递一个hash时使用*/<br />
typedef struct {<br />
	/*原始key值*/<br />
    ngx_str_t         key;<br />
	/*hash函数计算过key值*/<br />
    ngx_uint_t        key_hash;<br />
	/*hash表中value值*/<br />
    void             *value;<br />
} ngx_hash_key_t;

typedef ngx_uint_t (*ngx_hash_key_pt) (u_char *data, size_t len);

/*普通hash表初始化函数*/<br />
typedef struct {<br />
	/*hash表指针*/<br />
    ngx_hash_t       *hash;<br />
	/*未使用*/<br />
    ngx_hash_key_pt   key;

	/*hash表中容纳最大元素数量*/<br />
    ngx_uint_t        max_size;<br />
	/*hash表中桶的大小, 即容纳一个元素ngx_hash_elt_t大小*/<br />
    ngx_uint_t        bucket_size;

	/*hash表名字*/<br />
    char             *name;<br />
	/*内存池用于固定不变的一些数据结构使用*/<br />
    ngx_pool_t       *pool;<br />
	/*临时的内存池,由于内存池中内存是在内存池销毁时统一释放,因此这里对于临时变量使用*/<br />
    ngx_pool_t       *temp_pool;<br />
} ngx_hash_init_t;<br />
</code></pre>
<h2>hash表初始化</h2>
<p>初始化hash结构, nginx的hash将内存分为一系列桶, 每个桶内放置一个元素或者是所有冲突的元素, 下面是hash存储的示意图, hash表初始化时, 首先确定每个桶的大小, 其次确定hash表长度, 最后把传进函数中的数据, 按照规则放入hash表中.</p>
<pre class="prettyprint linenums"><code>                                                         hash表分布示意图

|-----一个桶大小bucket_size-----|-----一个桶大小bucket_size-----|-----一个桶大小bucket_size-----|-----一个桶大小bucket_size-----|........<br />
|--------key_hash%size=0--------|--------key_hash%size=1--------|---------key_hash%size=2-------|--------key_hash%size=3--------|........<br />
|------------------|--------|...|------------------|--------|...|------------------|--------|...|------------------|--------|...|........<br />
0  ngx_hash_elt_t     len     | 1  ngx_hash_elt_t      len    | 2  ngx_hash_elt_t      len      3  ngx_hash_elt_t      len      4........<br />
                              |                               |                    ........<br />
			      |                               |                    ........<br />
                  取余为0的冲突元素依次放入桶内        取余为1的冲突元素           ........<br />
</code></pre>
<pre class="prettyprint linenums"><code>/*计算桶中元素ngx_hash_elt_t大小, ngx_hash_elt_t结构体长度是可变的, 最后一个成员name[1], C语言惯用的手法, 可以让结构体本身和保存的数据连接在一起, 只是一个<br />
 *占位指针, 有时候我们定义为name[0], 因此长度也就是sizeof(value) + sizeof(u_short) + sizeof(name) + len, 但是我们看到下面并不是像我们计算的这样,<br />
 *由于sizeof(u_short) + sizeof(name)值肯定小于sizeof(void*), 结构体进行内存对齐时, 以成员最长长度进行对齐, 因此以sizeof(void*)进行对齐, 2代表的是sizeof(u_short).<br />
 */<br />
#define NGX_HASH_ELT_SIZE(name)                                               \<br />
    (sizeof(void *) + ngx_align((name)-&gt;key.len + 2, sizeof(void *)))<br />
</code></pre>
<pre class="prettyprint linenums"><code>                          ngx_hash_elt_t分布示意图<br />
|------------------------------|---------------|----------------------|<br />
           sizeof(void*)        sizeof(u_short)     长度为len的name(name只是一个占位指针)<br />
</code></pre>
<pre class="prettyprint linenums"><code>ngx_int_t<br />
ngx_hash_init(ngx_hash_init_t *hinit, ngx_hash_key_t *names, ngx_uint_t nelts)<br />
{<br />
    u_char          *elts;<br />
    size_t           len;<br />
    u_short         *test;<br />
    ngx_uint_t       i, n, key, size, start, bucket_size;<br />
    ngx_hash_elt_t  *elt, **buckets;

    for (n = 0; n &lt; nelts; n++) {<br />
		/*遍历判断是否有元素长度大于我们事先预估的桶大小, 一个桶的大小需要能够容纳所有的冲突元素*/<br />
        if (hinit-&gt;bucket_size &lt; NGX_HASH_ELT_SIZE(&amp;names[n]) + sizeof(void *))<br />
        {<br />
            ngx_log_error(NGX_LOG_EMERG, hinit-&gt;pool-&gt;log, 0,<br />
                          &quot;could not build the %s, you should &quot;<br />
                          &quot;increase %s_bucket_size: %i&quot;,<br />
                          hinit-&gt;name, hinit-&gt;name, hinit-&gt;bucket_size);<br />
            return NGX_ERROR;<br />
        }<br />
    }

    test = ngx_alloc(hinit-&gt;max_size * sizeof(u_short), hinit-&gt;pool-&gt;log);<br />
    if (test == NULL) {<br />
        return NGX_ERROR;<br />
    }

	/*上面比较时,加了一个指针长度, 这里减去*/<br />
    bucket_size = hinit-&gt;bucket_size - sizeof(void *);

	/*预估hash表大小, 这里以ngx_hash_elt_t为最小8字节进行计算*/<br />
    start = nelts / (bucket_size / (2 * sizeof(void *)));<br />
    start = start ? start : 1;

    if (hinit-&gt;max_size &gt; 10000 &amp;&amp; nelts &amp;&amp; hinit-&gt;max_size / nelts &lt; 100) {<br />
        start = hinit-&gt;max_size - 1000;<br />
    }

    for (size = start; size &lt;= hinit-&gt;max_size; size++) {

        ngx_memzero(test, size * sizeof(u_short));

        for (n = 0; n &lt; nelts; n++) {<br />
            if (names[n].key.data == NULL) {<br />
                continue;<br />
            }

            key = names[n].key_hash % size;<br />
			/*累加冲突元素的长度*/<br />
            test[key] = (u_short) (test[key] + NGX_HASH_ELT_SIZE(&amp;names[n]));

			/*元素大小大于桶大小, 累加size值, 重新进行分配*/<br />
            if (test[key] &gt; (u_short) bucket_size) {<br />
                goto next;<br />
            }<br />
        }

        goto found;

    next:

        continue;<br />
    }

    ngx_log_error(NGX_LOG_WARN, hinit-&gt;pool-&gt;log, 0,<br />
                  &quot;could not build optimal %s, you should increase &quot;<br />
                  &quot;either %s_max_size: %i or %s_bucket_size: %i; &quot;<br />
                  &quot;ignoring %s_bucket_size&quot;,<br />
                  hinit-&gt;name, hinit-&gt;name, hinit-&gt;max_size,<br />
                  hinit-&gt;name, hinit-&gt;bucket_size, hinit-&gt;name);

found:

	/*重置记录元素位置的临时数组*/<br />
    for (i = 0; i &lt; size; i++) {<br />
        test[i] = sizeof(void *);<br />
    }

    for (n = 0; n &lt; nelts; n++) {<br />
        if (names[n].key.data == NULL) {<br />
            continue;<br />
        }

        key = names[n].key_hash % size;<br />
        test[key] = (u_short) (test[key] + NGX_HASH_ELT_SIZE(&amp;names[n]));<br />
    }

    len = 0;

	/*计算所有元素总长度*/<br />
    for (i = 0; i &lt; size; i++) {<br />
        if (test[i] == sizeof(void *)) {<br />
            continue;<br />
        }

		/*此处进行了字节对齐, 加快访存速度*/<br />
        test[i] = (u_short) (ngx_align(test[i], ngx_cacheline_size));

        len += test[i];<br />
    }

	/*hash表为size个桶分配内存,保存所有桶的指针*/<br />
    if (hinit-&gt;hash == NULL) {<br />
        hinit-&gt;hash = ngx_pcalloc(hinit-&gt;pool, sizeof(ngx_hash_wildcard_t)<br />
                                             + size * sizeof(ngx_hash_elt_t *));<br />
        if (hinit-&gt;hash == NULL) {<br />
            ngx_free(test);<br />
            return NGX_ERROR;<br />
        }

        buckets = (ngx_hash_elt_t **)<br />
                      ((u_char *) hinit-&gt;hash + sizeof(ngx_hash_wildcard_t));

    } else {<br />
        buckets = ngx_pcalloc(hinit-&gt;pool, size * sizeof(ngx_hash_elt_t *));<br />
        if (buckets == NULL) {<br />
            ngx_free(test);<br />
            return NGX_ERROR;<br />
        }<br />
    }

	/*整个hash表分配内存*/<br />
    elts = ngx_palloc(hinit-&gt;pool, len + ngx_cacheline_size);<br />
    if (elts == NULL) {<br />
        ngx_free(test);<br />
        return NGX_ERROR;<br />
    }

    elts = ngx_align_ptr(elts, ngx_cacheline_size);

    for (i = 0; i &lt; size; i++) {<br />
        if (test[i] == sizeof(void *)) {<br />
            continue;<br />
        }

        buckets[i] = (ngx_hash_elt_t *) elts;<br />
        elts += test[i];

    }

	/*重置记录元素位置临时数组*/<br />
    for (i = 0; i &lt; size; i++) {<br />
        test[i] = 0;<br />
    }

	/*循环遍历将所有元素, 填入hash表中*/<br />
    for (n = 0; n &lt; nelts; n++) {<br />
        if (names[n].key.data == NULL) {<br />
            continue;<br />
        }

        key = names[n].key_hash % size;<br />
        elt = (ngx_hash_elt_t *) ((u_char *) buckets[key] + test[key]);

        elt-&gt;value = names[n].value;<br />
        elt-&gt;len = (u_short) names[n].key.len;

        ngx_strlow(elt-&gt;name, names[n].key.data, names[n].key.len);

        test[key] = (u_short) (test[key] + NGX_HASH_ELT_SIZE(&amp;names[n]));<br />
    }

	/*hash表中空缺的位置置空*/<br />
    for (i = 0; i &lt; size; i++) {<br />
        if (buckets[i] == NULL) {<br />
            continue;<br />
        }

        elt = (ngx_hash_elt_t *) ((u_char *) buckets[i] + test[i]);

        elt-&gt;value = NULL;<br />
    }

    ngx_free(test);

    hinit-&gt;hash-&gt;buckets = buckets;<br />
    hinit-&gt;hash-&gt;size = size;

    return NGX_OK;<br />
}<br />
</code></pre>
<h2>hash表查找</h2>
<p>了解了hash表存储结构, 从hash表中查找元素变得简单多了, 首先取出元素对应的桶, 然后依次比较name是否相等, 相等则返回对应值value</p>
<pre class="prettyprint linenums"><code>void *<br />
ngx_hash_find(ngx_hash_t *hash, ngx_uint_t key, u_char *name, size_t len)<br />
{<br />
    ngx_uint_t       i;<br />
    ngx_hash_elt_t  *elt;

	/*取出元素对应的桶位置*/<br />
    elt = hash-&gt;buckets[key % hash-&gt;size];

    if (elt == NULL) {<br />
        return NULL;<br />
    }

    while (elt-&gt;value) {<br />
        if (len != (size_t) elt-&gt;len) {<br />
            goto next;<br />
        }

		/*比较对应的name值*/<br />
        for (i = 0; i &lt; len; i++) {<br />
            if (name[i] != elt-&gt;name[i]) {<br />
                goto next;<br />
            }<br />
        }

        return elt-&gt;value;

    next:

		/*桶内依次取值, 存时内存进行了对齐, 取时同样需要对齐*/<br />
        elt = (ngx_hash_elt_t *) ngx_align_ptr(&amp;elt-&gt;name[0] + elt-&gt;len,<br />
                                               sizeof(void *));<br />
        continue;<br />
    }

    return NULL;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqljv5e9.html">Invoke的使用情景</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rglnd8.html">LINUX 查看当前系统的内存使用情况</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ewz7x8.html">iOS 自定义图片和文字垂直显示按钮&amp;lt&semi;上面是图片&comma;文字显示下面&amp;gt&semi;</a>
		</li>
						<li><a href="https://www.batexi.com/a/49grxleq.html">C&num;项目中常用到的设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnxo2j9.html">C&plus;&plus; 多重集的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x0vdz8.html">Java自带的keytool命令</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gm3jz09.html">wifi current SSID</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wmnlxq.html">linux which  查看可执行文件的位置</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xnl3n9.html">CAS Ticket SSO 登录流程图</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjem3k9.html">JNI编程&lpar;二&rpar; &mdash;&mdash; 让C&plus;&plus;和Java相互调用&lpar;2&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vn42n8.html">php随机生成福彩双色球号码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnvz7rq.html">Ubuntu 安装 JDK 7 &sol; JDK8 的两种方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z1pl3n9.html">实现QQ空间图片预览效果</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1k35z9.html">Matrix的set&comma;pre&comma;post调用顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwd26738.html">Android Toast简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zo3vdvq.html">&lbrack;USACO09OCT&rsqb;热浪Heat Wave</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kp24p39.html">解决 CefSharp WPF控件不能使用输入法输入中文的问题（代码已提交到 github）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdnlej9.html">---&mdash;&mdash;&mdash;&mdash;for循环打印爱心</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwxley8.html">事件监听addEventListener----attachEvent</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w2jrwq.html">10&period;for</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwdn30k8.html">PS 颜色表大全-CMYK颜色表（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mny3w6q.html">C&num; Windows - ListBox&amp;amp&semi;CheckedListBox</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnyo5oq.html">【数位DP】Hdu 3652&colon;B-number</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1650x9.html">BZOJ 3173  &lbrack;Tjoi2013&rsqb; 最长上升子序列 解题报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwd4d5y8.html">网站404&comma;500错误页面的处理&comma;及500异常写入errorLog日志</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2wywnoq.html">import&comma;reload&comma;&lowbar;&lowbar;import&lowbar;&lowbar;在python中的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdkg378.html">压缩&sol;解压 zip 时遇到 java&period;lang&period;IllegalArgumentException&colon; MALFORMED</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mnr200q.html">H264&sol;AVC视频解码时AVC1和H264的区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x73j08.html">ANDROID&lowbar;MARS学习笔记&lowbar;S01&lowbar;012&lowbar;RatingBar</a>
			</li>
						<li><a href="https://www.batexi.com/a/8okldzl9.html">hadoop博客</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
